org.apache.commons.pool2

## Interface PooledObject<T>

- Type Parameters:
    `T` - the type of object in the pool
  All Superinterfaces:
    Comparable<PooledObject<T>>
  All Known Implementing Classes:
    DefaultPooledObject, PooledSoftReference

      public interface PooledObject<T>
      extends Comparable<PooledObject<T>>

  Defines the wrapper that is used to track the additional information, such as state, for the pooled objects.

  Implementations of this class are required to be thread-safe.

  Since:
    2.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `allocate()` Allocates the object.
    `int` | `compareTo(PooledObject<T> other)` Orders instances based on idle time - i.e.
    `boolean` | `deallocate()` Deallocates the object and sets it `IDLE` if it is currently `ALLOCATED`.
    `boolean` | `endEvictionTest(Deque<PooledObject<T>> idleQueue)` Called to inform the object that the eviction test has ended.
    `boolean` | `equals(Object obj)`
    `default Duration` | `getActiveTime()` Gets the amount of time this object last spent in the active state (it may still be active in which case subsequent calls will return an increased value).
    `long` | `getActiveTimeMillis()` Gets the amount of time in milliseconds this object last spent in the active state (it may still be active in which case subsequent calls will return an increased value).
    `default long` | `getBorrowedCount()` Gets the number of times this object has been borrowed.
    `long` | `getCreateTime()` Gets the time (using the same basis as `System.currentTimeMillis()`) that this object was created.
    `default Duration` | `getIdleTime()` Gets the amount of time that this object last spend in the idle state (it may still be idle in which case subsequent calls will return an increased value).
    `long` | `getIdleTimeMillis()` Gets the amount of time in milliseconds that this object last spend in the idle state (it may still be idle in which case subsequent calls will return an increased value).
    `long` | `getLastBorrowTime()` Gets the time the wrapped object was last borrowed.
    `long` | `getLastReturnTime()` Gets the time the wrapped object was last returned.
    `long` | `getLastUsedTime()` Gets an estimate of the last time this object was used.
    `T` | `getObject()` Gets the underlying object that is wrapped by this instance of `PooledObject`.
    `PooledObjectState` | `getState()` Gets the state of this object.
    `int` | `hashCode()`
    `void` | `invalidate()` Sets the state to `INVALID`
    `void` | `markAbandoned()` Marks the pooled object as abandoned.
    `void` | `markReturning()` Marks the object as returning to the pool.
    `void` | `printStackTrace(PrintWriter writer)` Prints the stack trace of the code that borrowed this pooled object and the stack trace of the last code to use this object (if available) to the supplied writer.
    `void` | `setLogAbandoned(boolean logAbandoned)` Is abandoned object tracking being used? If this is true the implementation will need to record the stack trace of the last caller to borrow this object.
    `default void` | `setRequireFullStackTrace(boolean requireFullStackTrace)` Configures the stack trace generation strategy based on whether or not fully detailed stack traces are required.
    `boolean` | `startEvictionTest()` Attempts to place the pooled object in the `PooledObjectState.EVICTION` state.
    `String` | `toString()` Provides a String form of the wrapper for debug purposes.
    `void` | `use()` Record the current stack trace as the last time the object was used.

- - ### Method Detail

    - #### allocate

          boolean allocate()

      Allocates the object.
      Returns:
        `true` if the original state was `IDLE`

    - #### compareTo

          int compareTo(PooledObject<T> other)

      Orders instances based on idle time - i.e. the length of time since the instance was returned to the pool. Used by the GKOP idle object evictor.

      Note: This class has a natural ordering that is inconsistent with equals if distinct objects have the same identity hash code.

      Specified by:
        `compareTo` in interface `Comparable<PooledObject<T>>`

    - #### deallocate

          boolean deallocate()

      Deallocates the object and sets it `IDLE` if it is currently `ALLOCATED`.
      Returns:
        `true` if the state was `ALLOCATED`

    - #### endEvictionTest

          boolean endEvictionTest(Deque<PooledObject<T>> idleQueue)

      Called to inform the object that the eviction test has ended.
      Parameters:
        `idleQueue` - The queue of idle objects to which the object should be returned
      Returns:
        Currently not used

    - #### equals

          boolean equals(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getActiveTime

          default Duration getActiveTime()

      Gets the amount of time this object last spent in the active state (it may still be active in which case subsequent calls will return an increased value).
      Returns:
        The duration last spent in the active state
      Since:
        2.12.0

    - #### getActiveTimeMillis

          long getActiveTimeMillis()

      Gets the amount of time in milliseconds this object last spent in the active state (it may still be active in which case subsequent calls will return an increased value).
      Returns:
        The time in milliseconds last spent in the active state

    - #### getBorrowedCount

          default long getBorrowedCount()

      Gets the number of times this object has been borrowed.
      Returns:
        -1 by default for old implementations prior to release 2.7.0.
      Since:
        2.7.0

    - #### getCreateTime

          long getCreateTime()

      Gets the time (using the same basis as `System.currentTimeMillis()`) that this object was created.
      Returns:
        The creation time for the wrapped object

    - #### getIdleTime

          default Duration getIdleTime()

      Gets the amount of time that this object last spend in the idle state (it may still be idle in which case subsequent calls will return an increased value).
      Returns:
        The amount of time in last spent in the idle state.
      Since:
        2.10.0

    - #### getIdleTimeMillis

          long getIdleTimeMillis()

      Gets the amount of time in milliseconds that this object last spend in the idle state (it may still be idle in which case subsequent calls will return an increased value).
      Returns:
        The time in milliseconds last spent in the idle state

    - #### getLastBorrowTime

          long getLastBorrowTime()

      Gets the time the wrapped object was last borrowed.
      Returns:
        The time the object was last borrowed

    - #### getLastReturnTime

          long getLastReturnTime()

      Gets the time the wrapped object was last returned.
      Returns:
        The time the object was last returned

    - #### getLastUsedTime

          long getLastUsedTime()

      Gets an estimate of the last time this object was used. If the class of the pooled object implements `TrackedUse`, what is returned is the maximum of `TrackedUse.getLastUsed()` and `getLastBorrowTime()`; otherwise this method gives the same value as `getLastBorrowTime()`.
      Returns:
        the last time this object was used

    - #### getObject

          T getObject()

      Gets the underlying object that is wrapped by this instance of `PooledObject`.
      Returns:
        The wrapped object

    - #### getState

          PooledObjectState getState()

      Gets the state of this object.
      Returns:
        state

    - #### hashCode

          int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### invalidate

          void invalidate()

      Sets the state to `INVALID`

    - #### markAbandoned

          void markAbandoned()

      Marks the pooled object as abandoned.

    - #### markReturning

          void markReturning()

      Marks the object as returning to the pool.

    - #### printStackTrace

          void printStackTrace(PrintWriter writer)

      Prints the stack trace of the code that borrowed this pooled object and the stack trace of the last code to use this object (if available) to the supplied writer.
      Parameters:
        `writer` - The destination for the debug output

    - #### setLogAbandoned

          void setLogAbandoned(boolean logAbandoned)

      Is abandoned object tracking being used? If this is true the implementation will need to record the stack trace of the last caller to borrow this object.
      Parameters:
        `logAbandoned` - The new configuration setting for abandoned object tracking

    - #### setRequireFullStackTrace

          default void setRequireFullStackTrace(boolean requireFullStackTrace)

      Configures the stack trace generation strategy based on whether or not fully detailed stack traces are required. When set to false, abandoned logs may only include caller class information rather than method names, line numbers, and other normal metadata available in a full stack trace.
      Parameters:
        `requireFullStackTrace` - the new configuration setting for abandoned object logging
      Since:
        2.7.0

    - #### startEvictionTest

          boolean startEvictionTest()

      Attempts to place the pooled object in the `PooledObjectState.EVICTION` state.
      Returns:
        `true` if the object was placed in the `PooledObjectState.EVICTION` state otherwise `false`

    - #### toString

          String toString()

      Provides a String form of the wrapper for debug purposes. The format is not fixed and may change at any time.

      Overrides:
        `toString` in class `Object`

    - #### use

          void use()

      Record the current stack trace as the last time the object was used.

Copyright © 2001–2021 The Apache Software Foundation. All rights reserved.